<?php
session_start();
date_default_timezone_set("America/Bogota");

include("../conexion/conexion.php");
$conne = new conexion();
$conn = $conne->conectar();

$fechaHoraActual = new DateTime();
$fechaHoraActual->sub(new DateInterval('PT10M'));
$fechaHoraActual = $fechaHoraActual->format('Y-m-d\TH:i:s.u\Z');
$fechaHoraActual = substr($fechaHoraActual, 0, 23) . 'Z';

$nitBuscado = $_SESSION["nitEm"]; // <-- nit viene de sesión
$input = json_decode(file_get_contents('php://input'), true);

$bodega = $input['bodega'] ?? null;

$empresa="SELECT * FROM `empresa` where bodegaEm=$bodega";

$resulta = $conn->query($empresa);
$fila = $resulta->fetch_assoc();

// Supongamos que el código que necesitas se llama 'codigoDrogueria'
$codeDrogueria = $fila['codigo'] ?? null;
$bodegaRe =$bodega;


if (strlen($codeDrogueria) <= 3) {
    echo json_encode(["error" => "No Autorizado"]);
    exit();
}


    $sql = "
    SELECT CONCAT(
        '[',
        GROUP_CONCAT(
            JSON_OBJECT(
                'CodigoDrogueria', $codeDrogueria,
                'FechaHora', '$fechaHoraActual',
                'NitProveedor', 860026123,
                'NombreProveedor', 'copidrogas',
                'Cantidad', CAST(inventario AS UNSIGNED),
                'Costo', CASE 
                    WHEN CostoCajaP = 0 THEN 1
                    ELSE CAST(CostoCajaP AS UNSIGNED)
                END,
                'PrecioVenta',CASE 
                    WHEN VentaCajaP = 0 THEN 1
                    ELSE CAST(VentaCajaP AS UNSIGNED)
                END, 
                'PorcentajeIVA', CASE 
                    WHEN impuesto = 19 THEN 4
                    WHEN impuesto = 5 THEN 5
                    WHEN impuesto = 0 THEN 1
                    ELSE 2
                END,
                'CodigoProducto', codigo,
                'Ean13',CASE 
                    WHEN barras = 0 THEN 1
                    ELSE CAST(barras AS UNSIGNED)
                END,  
                'NombreProducto', nombre,
                'Unidad', 1,
                'ContenidoUnidad',CASE 
                    WHEN factor = 0 THEN 1
                    ELSE CAST(factor AS UNSIGNED)
                END  
            )
            SEPARATOR ','
        ),
        ']'
    ) AS json_result
    FROM (
        SELECT *
        FROM productos INNER JOIN inventarios on productos.codigo=inventarios.codigoProd
        WHERE TotalInventario >= 1
        and idbodega=$bodegaRe
        LIMIT 4000
    ) AS limited_productos;
";

//}

$result = $conn->query($sql);

if ($result === false) {
    echo json_encode(["error" => "Error SQL: " . $conn->error]);
    exit();
}
$row = $result->fetch_assoc();
$data= $row['json_result'];

// $productos = [];
// while ($row = $result->fetch_assoc()) {
//     $producto = [
//         "CodigoDrogueria" => $codeDrogueria,
//         "FechaHora" => $fechaHoraActual,
//         "NitProveedor" => 860026123,
//         "NombreProveedor" => "copidrogas",
//         "Cantidad" => (int)$row['TotalInventario'],
//         "Costo" => (int)($row['CostoCajaP'] ?: 1),
//         "PrecioVenta" => (int)($row['VentaCajaP'] ?: 1),
//         "PorcentajeIVA" => ($row['impuesto'] == 19) ? 4 : (($row['impuesto'] == 5) ? 5 : (($row['impuesto'] == 0) ? 1 : 2)),
//         "CodigoProducto" => $row['codigo'],
//         "Ean13" => (int)($row['barras'] ?: 1),
//         "NombreProducto" => $row['nombre'],
//         "Unidad" => 1,
//         "ContenidoUnidad" => (int)($row['factor'] ?: 1),
//     ];
//     $productos[] = $producto;
// }

$conn->close();

echo json_encode([
    "codeDrogueria" => $codeDrogueria,
    "productos" =>$data
]);
?>